package run.evan.hotspotip;

import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

import de.robv.android.xposed.IXposedHookLoadPackage;
import de.robv.android.xposed.XC_MethodReplacement;
import de.robv.android.xposed.XposedBridge;
import de.robv.android.xposed.XposedHelpers;
import de.robv.android.xposed.callbacks.XC_LoadPackage;

public class MainHook implements IXposedHookLoadPackage {
    @Override
    public void handleLoadPackage(XC_LoadPackage.LoadPackageParam loadPackageParam) throws Throwable {
        if (loadPackageParam.packageName.equals("com.android.networkstack.tethering.inprocess")) {
            XposedBridge.log("Hotspot Ip init");
            XposedHelpers.findAndHookMethod("com.android.networkstack.tethering.PrivateAddressCoordinator", loadPackageParam.classLoader, "requestDownstreamAddress", "android.net.ip.IpServer", boolean.class, new XC_MethodReplacement() {
                @Override
                protected Object replaceHookedMethod(MethodHookParam methodHookParam) throws Throwable {
                    Class linkAddressClass = XposedHelpers.findClass("android.net.LinkAddress", loadPackageParam.classLoader);
                    Constructor linkAddressConstructor = linkAddressClass.getConstructor(String.class);
                    Class ipServerClass = XposedHelpers.findClass("android.net.ip.IpServer", loadPackageParam.classLoader);
                    Method interfaceTypeMethod = ipServerClass.getDeclaredMethod("interfaceType");
                    int iFaceType = (int) interfaceTypeMethod.invoke(methodHookParam.args[0]);
                    switch (iFaceType) {
                        case 3:
                            return linkAddressConstructor.newInstance("192.168.49.1/24");
                        case 0:
                            return linkAddressConstructor.newInstance("192.168.6.1/24");
                        case 1:
                            return linkAddressConstructor.newInstance("192.168.7.1/24");
                        default:
                            return linkAddressConstructor.newInstance("192.168.8.1/24");
                    }
                }
            });
        }
    }
}
